/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __MODEL_FILTER_ECHO_H_
#define __MODEL_FILTER_ECHO_H_

#include "gdamechobase.h"

GtkType gdam_echo_get_type();
#define GDAM_TYPE_ECHO			(gdam_echo_get_type ())
#define GDAM_ECHO(obj)			(GTK_CHECK_CAST ((obj), GDAM_TYPE_ECHO, GdamEcho))
#define GDAM_ECHO_CLASS(klass)		(GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_ECHO, GdamEchoClass))
#define GDAM_IS_ECHO(obj)		(GTK_CHECK_TYPE ((obj), GDAM_TYPE_ECHO))
#define GDAM_IS_ECHO_CLASS(klass)	(GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_ECHO))

typedef struct _GdamEcho GdamEcho;
typedef struct _GdamEchoClass GdamEchoClass;

struct _GdamEchoClass
{
	GdamEchoBaseClass	echo_base_class;
	void 			(*update_delay)		(GdamEcho* echo,
							 gdouble   delay);
};


struct _GdamEcho 
{
	GdamEchoBase		echo_base;

	int			echoed;
	float			beat_factor;
	gdouble			delay;
	gdouble			gain;
	int			echoes;
	gdouble			decay;
};

GdamEcho*	gdam_echo_new		();
void		gdam_echo_free		(GdamEcho*		echo);
void 		gdam_echo_set_delay	(GdamEcho* 		echo, 
					 double 		delay);

#endif
