/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __MODEL_FILTER_RESPEED_H_
#define __MODEL_FILTER_RESPEED_H_

#include <gdam/client/gdamchannel.h>
#include "gdamfilter.h"
#include "gdaminfomanager.h"

typedef struct _GdamRespeed GdamRespeed;
typedef struct _GdamRespeedClass GdamRespeedClass;

GtkType gdam_respeed_get_type();
#define GDAM_TYPE_RESPEED			(gdam_respeed_get_type ())
#define GDAM_RESPEED(obj)			(GTK_CHECK_CAST ((obj), GDAM_TYPE_RESPEED, GdamRespeed))
#define GDAM_RESPEED_CLASS(klass)		(GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_RESPEED, GdamRespeedClass))
#define GDAM_IS_RESPEED(obj)		(GTK_CHECK_TYPE ((obj), GDAM_TYPE_RESPEED))
#define GDAM_IS_RESPEED_CLASS(klass)	(GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_RESPEED))

struct _GdamRespeedClass {
	GdamFilterClass		filter_class;
	void			(*tempo_changed) (GdamRespeed*   respeed,
						  gdouble	 tempo);
};

struct _GdamRespeed {
	GdamFilter		filter;
	guint 			respeed_id;
    	gdouble 		rate;
	int			input_block_size;
};

void		gdam_respeed_set_rate		(GdamRespeed*	    respeed,
					 	 gdouble 	    newrate);

#endif
