/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_DEVICE_CORE_AUDIO_H_
#define __GDAM_DEVICE_CORE_AUDIO_H_

#include <gdam/common/gdamautoconf.h>

#if HAVE_CORE_AUDIO

typedef struct _GdamDeviceCoreAudio GdamDeviceCoreAudio;
typedef struct _GdamDeviceCoreAudioClass GdamDeviceCoreAudioClass;

#include "gdamcallbackdevice.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdam_device_core_audio_get_type();
#define GDAM_TYPE_DEVICE_CORE_AUDIO			(gdam_device_core_audio_get_type ())
#define GDAM_DEVICE_CORE_AUDIO(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_DEVICE_CORE_AUDIO, GdamDeviceCoreAudio))
#define GDAM_DEVICE_CORE_AUDIO_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_DEVICE_CORE_AUDIO, GdamDeviceCoreAudioClass))
#define GDAM_IS_DEVICE_CORE_AUDIO(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_DEVICE_CORE_AUDIO))
#define GDAM_IS_DEVICE_CORE_AUDIO_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_DEVICE_CORE_AUDIO))

#include <CoreAudio/CoreAudio.h>

struct _GdamDeviceCoreAudioClass {
  GdamCallbackDeviceClass		callback_device_class;
};

struct _GdamDeviceCoreAudio {
  GdamCallbackDevice		callback_device;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* HAVE_CORE_AUDIO  */

#endif
