/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_CHAT_SKIN_H_
#define __GDAM_CHAT_SKIN_H_

#include <gdam/skin/gdamskin.h>
#include <gtk/gtkeditable.h>

typedef struct _GdamChatSkin GdamChatSkin;
typedef struct _GdamChatSkinClass GdamChatSkinClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdam_chat_skin_get_type();
#define GDAM_TYPE_CHAT_SKIN			(gdam_chat_skin_get_type ())
#define GDAM_CHAT_SKIN(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_CHAT_SKIN, GdamChatSkin))
#define GDAM_CHAT_SKIN_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_CHAT_SKIN, GdamChatSkinClass))
#define GDAM_IS_CHAT_SKIN(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_CHAT_SKIN))
#define GDAM_IS_CHAT_SKIN_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_CHAT_SKIN))

/* TODO: username from history file */

struct _GdamChatSkinClass {
	GdamSkinClass		skin_class;
};
struct _GdamChatSkin {
	GdamSkin			skin;

	/* The name we are known by */
	char		               *username;

	char		               *recipient;
	GtkEditable		       *message_entry;
	GtkEditable		       *log_entry;

	guint 				chat_trap_id;
	int				lead_id;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
