/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAMECHOSKIN__H_
#define __GDAMECHOSKIN__H_

#include "gdamskin.h"
#include <gdam/component/gdamecho.h>


typedef struct _GdamEchoSkinClass GdamEchoSkinClass;
typedef struct _GdamEchoSkin GdamEchoSkin;


GtkType gdam_echoskin_get_type();
#define GDAM_TYPE_ECHOSKIN              (gdam_echoskin_get_type ())
#define GDAM_ECHOSKIN(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_ECHOSKIN, GdamEchoSkin))
#define GDAM_ECHOSKIN_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_ECHOSKIN, GdamEchoSkinClass))
#define GDAM_IS_ECHOSKIN(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_ECHOSKIN))
#define GDAM_IS_ECHOSKIN_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_ECHOSKIN))

struct _GdamEchoSkinClass {
	GdamSkinClass		skin_class;
};


struct _GdamEchoSkin {
	GdamSkin		base;
};

typedef struct _NudgeInfo {
	GdamEcho* 		echo;
	float			amount;
} NudgeInfo;


#endif
