/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GTK_MESSAGE_QUEUE_H_
#define __GTK_MESSAGE_QUEUE_H_

#include <gtk/gtktext.h>

typedef struct _GtkMessageQueue GtkMessageQueue;
struct _GtkMessageQueue {
	GtkText*		text;
	GtkAdjustment*		v_adjustment;

	int			max_entries;
	int			num_entries;
	int			max_bytes;
	int			num_bytes;

	GSList*			first_bytes;
	GSList*			last_bytes;
};


GtkMessageQueue*   gtk_message_queue_new    (int              max_text,
                                             int              max_entries);
void               gtk_message_queue_append (GtkMessageQueue* message_queue,
                                             const char*      text);
void               gtk_message_queue_destroy(GtkMessageQueue* message_queue);

#endif
